# -*- encoding: utf-8 -*-

import random
from HamstersAndPlague.Critters import *
from HamstersAndPlague.ContentControllers import TextureController

class CritterManager:
	
	def __init__(self):
		pass
	
	def Reset(self, group):
		self.spriteGroup = group
		self.males = []
		self.females = []
		self.doctors = []
		self.plagued = []
	
	def SpawnCritter(self, cType, cAge):
		if cType == "M":
			critter = Male(TextureController.scaledMaleAtlas, cAge)
			self.males.append(critter)
		
		elif cType == "F":
			critter = Female(TextureController.scaledFemaleAtlas, cAge)
			self.females.append(critter)
			
		elif cType == "D":
			critter = Doctor(TextureController.scaledDoctorAtlas, cAge)
			self.doctors.append(critter)
			
		elif cType == "P":
			critter = Plagued(TextureController.scaledPlague, cAge)
			self.plagued.append(critter)
			
		elif cType == "R":
			critter = self.SpawnCritter(GENDER_DISTRIBUTION[random.randint(0, len(GENDER_DISTRIBUTION) - 1)], cAge)
						
		self.spriteGroup.add(critter)				
		
		return critter
		
	def ManageCritters(self):
			
		for p in self.plagued[:]: 
			p.SpreadPlague()
			
		for f in self.females[:]:
			f.CheckMates()
			
		for m in self.males[:]:
			if m.Age(): 
				self.males.remove(m)
				m.kill()
				
		for f in self.females[:]:
			if f.Age():
				self.females.remove(f)
				f.kill()
				
		for d in self.doctors[:]:
			if d.Age():
				self.doctors.remove(d)
				d.kill()
				
		if len(self.females) == 0 or len(self.males) == 0:
			return True
		else:
			return False
		
				
	def RemovePlagued(self, critter):
		if type(critter) == Male:
			self.males.remove(critter)
		
		elif type(critter) == Female:
			self.females.remove(critter)
			
		elif type(critter) == Doctor:
			self.doctors.remove(critter)
			
		critter.kill()
	
	def CreateSprites(self, group):
		for c in self.males + self.females + self.doctors + self.plagued:
			group.add(c)
			
	def Draw(self):
		for c in self.plagued: #self.males + self.females + self.doctors + self.plagued:
			c.Draw()
			