# -*- encoding: utf-8 -*-

import pygame
from HamstersAndPlague.ContentControllers import TextureController, BackgroundController
from HamstersAndPlague.Constants import *

class CycleCounter(pygame.sprite.DirtySprite):
	
	def __init__(self):
		pygame.sprite.DirtySprite.__init__(self)
		self.rect = pygame.Rect(CYCLECOUNTER_X, CYCLECOUNTER_Y, CYCLECOUNTER_WIDTH, CYCLECOUNTER_HEIGHT)
		self.image = pygame.transform.smoothscale(TextureController.cycleBar, (CYCLECOUNTER_WIDTH, CYCLECOUNTER_HEIGHT))
		
	def Reset(self):
		self.size = 1.0
		self.image = pygame.transform.smoothscale(TextureController.cycleBar, (CYCLECOUNTER_WIDTH, CYCLECOUNTER_HEIGHT))
		self.rect.height = CYCLECOUNTER_HEIGHT
		self.rect.top = CYCLECOUNTER_Y
		
	def Decrement(self, newSize):
		if newSize < 0: 
			newSize = 0
			
		self.size = newSize
		self.rect.height = int(newSize * CYCLECOUNTER_HEIGHT + 0.5)
		self.rect.top = int(CYCLECOUNTER_Y + (CYCLECOUNTER_HEIGHT - self.rect.height))
		self.image = pygame.transform.smoothscale(TextureController.cycleBar, self.rect.size)
		self.dirty = 1
		
		#change = self.size - newSize
		#shrink = int(change * CYCLECOUNTER_HEIGHT + 0.5)
		#self.rect.inflate_ip(0, -1 * shrink)
		#self.rect.move_ip(0, shrink)
		#self.image = pygame.transform.smoothscale(TextureController.cycleBar, self.rect.size)
		#self.size = newSize
		
		

class DigitString(pygame.sprite.DirtySprite):
	
	def __init__(self, digits, x, y):
		pygame.sprite.DirtySprite.__init__(self)
		self.image = pygame.Surface((LETTER_WIDTH * digits, TextureController.digitsAtlas.get_height()))
		self.digits = digits
		self.value = 0
		self.rect = pygame.Rect(x, y, self.image.get_width(), self.image.get_height())
		
	def SetValue(self, value, bg):
		self.value = value
		digits = list(str(self.value))
		digits.reverse()
		
		self.image.blit(bg.subsurface(self.rect), (0, 0))
		
		
		for i, d in enumerate(digits):
			if d == "+":
				pass
			
			elif d == "/":
				pass
			
			else:
				d = int(d)
				self.image.blit(TextureController.digitsAtlas.subsurface((d * LETTER_WIDTH, 0, LETTER_WIDTH, self.rect.height)), (LETTER_SIZE * (self.digits - i - 1), 0))
		
		self.dirty = 1
		
	